/*
// dummy debug dump ------------------------------------------------------------------
function ddd(msg) 
{
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("_" + msg + "_");
}
*/

function InFormEnterCommonType () 
{

//------------------------------------------------------------
this.g_Preferences = 0;
this.g_FormHistory = 0;

this.g_IsOn = 1;
this.g_OptionsPlacement = 0;
this.g_MarkerRightClick = 0;
this.g_MarkersMode = 1;
this.g_ColorizeItems = 0;

this.g_MenuSet = "";
this.g_MenuSetDefault = "";
this.g_MenuItemsCount = 0;

this.g_LastPassword = "";

this.Init = function()
{
 this.g_Preferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
 if ("nsIFormHistory" in Components.interfaces)
  this.g_FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory);
 if ("nsIFormHistory2" in Components.interfaces)
  this.g_FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2);
}

this.ReadState = function()
{
 this.g_IsOn = this.GetPrefInt("InFormEnter.On", 1);
 this.g_OptionsPlacement = this.GetPrefInt("InFormEnter.OptionsPlacement", 0);
 this.g_MarkerRightClick = this.GetPrefInt("InFormEnter.MarkerRightClick", 0);
 this.g_MarkersMode = this.GetPrefInt("InFormEnter.MarkersMode", 1);
 this.g_ColorizeItems = this.GetPrefInt("InFormEnter.ColorizeItems2", 0);
}

//------------------------------------------------------------------------------
this.GetPrefInt = function(prefName, prefDefault)
{
 if (!this.g_Preferences.prefHasUserValue(prefName))
  this.g_Preferences.setIntPref(prefName, prefDefault);
 return this.g_Preferences.getIntPref(prefName);
}

//------------------------------------------------------------------------------
this.GetPrefChar = function(prefName, prefDefault)
{
 if (!this.g_Preferences.prefHasUserValue(prefName))
  this.g_Preferences.setCharPref(prefName, prefDefault);
 return this.g_Preferences.getCharPref(prefName);
}

//------------------------------------------------------------------------------
this.GetPropStr = function(id)
{
 var ife_strings = document.getElementById("ife_sb");
 return ife_strings.getString (id);
}

//------------------------------------------------------------------------------
this.CheckDefaultProfile = function()
{
 var ife_strings = document.getElementById("ife_sb");

 this.g_MenuSetDefault = "";
 for (var s=1; s<=8; s++)
  this.g_MenuSetDefault += (ife_strings.getString ("ife.default.line."+s) + "\n");

 this.g_MenuSet = this.GetPrefChar("InFormEnter.1.MenuSet", escape(this.g_MenuSetDefault));

 this.GetPrefChar("InFormEnter.Profiles", escape(ife_strings.getString ("ife.default.profile")) + "\t1");
 this.GetPrefInt("InFormEnter.ProfileCurrent", 1);
 this.GetPrefInt("InFormEnter.ProfileNext", 2);
}

//------------------------------------------------------------------------------
this.RandInt = function()
{
 return Math.round (Math.random()*10000);
}

//------------------------------------------------------------------------------
this.RandChar = function()
{
 var x, y;

 x = this.RandInt() % 3;

 if (x == 2)
  y = 48 + (this.RandInt() % 10);

 if (x == 1)
  y = 97 + (this.RandInt() % 26);

 if (x == 0)
  y = 65 + (this.RandInt() % 26);

 return String.fromCharCode(y);
}

//------------------------------------------------------------------------------
this.HideSharp = function(str)
{
 str = str.replace(/##/g, "\t");
 return str;
}

//------------------------------------------------------------------------------
this.UnhideSharp = function(str)
{
 str = str.replace(/\t/g, "#");
 return str;
}

//------------------------------------------------------------------------------
this.HideAt = function(str)
{
 str = str.replace(/@@/g, "\n");
 return str;
}

//------------------------------------------------------------------------------
this.UnhideAt = function(str)
{
 str = str.replace(/\n/g, "@@");
 return str;
}

//------------------------------------------------------------------------------
this.GetElementXY = function(element) 
{
 var offsetLeft = 0;
 var offsetTop = 0;
 while (element)
 {
  offsetLeft += element.offsetLeft;
  offsetTop += element.offsetTop;
  element = element.offsetParent;
 }
 
 if (navigator.userAgent.indexOf("Mac") != -1 && typeof document.body.leftMargin != "undefined")
 {
  offsetLeft += document.body.leftMargin;
  offsetTop += document.body.topMargin;
 }

 return {x:offsetLeft, y:offsetTop};
}

//------------------------------------------------------------------------------

this.Macro = function(command, runMode)
{
 var result = this.GetPropStr("ife.msg.macro.text");
 var tmp = command.split (":");

 if (tmp.length == 1) // macro without params
 {
  result = this.GetPropStr("ife.msg.macro.name");
  if (tmp[0] == "RLP")
   result = this.g_LastPassword;
  else
  if (tmp[0] == "SR")
   result = "#SR#";
 }

 if (tmp.length == 2) // macro with params
 {
  result = this.GetPropStr("ife.msg.macro.name");
  if (tmp[0] == "GP")
  {
   result = this.GetPropStr("ife.msg.macro.arguments");
   var param = parseInt (tmp[1]);
   if (param > 0 && param < 33)
   {
    result = "";
    var i=0;
    do
    {
     result += this.RandChar();
     i++;
    }while(i<param);

    if (runMode)
     this.g_LastPassword = result;
   }
  }
 }

 return this.HideAt(this.UnhideSharp(result));
}

//------------------------------------------------------------------------------
this.StrMaxInputLength = function(maxlength)
{
 var result; 
 if (maxlength == null)
  result = this.GetPropStr("ife.msg.field.length.unknown");
 else
  result = this.GetPropStr("ife.msg.field.length") + " " + maxlength;
 return result;
}

//------------------------------------------------------------------------------
this.CheckMenuItemLength = function(menu_name)
{
 var maxLength = 37;
 var textShort = menu_name;
 if (textShort.length > maxLength)
 {
  var sepText = "[...]"; // must be shorter maxLength
  var pos1 = (maxLength-sepText.length)/2;
  textShort = menu_name.substring(0, pos1);
  textShort += sepText;
  var pos2 = menu_name.length-pos1;
  textShort += menu_name.substring(pos2);
 }

 return textShort;
}

//------------------------------------------------------------------------------
this.IsStrInFormCache = function(inputName, str)
{
 if(this.g_FormHistory && this.g_IsOn && this.g_ColorizeItems)
  return this.g_FormHistory.entryExists(inputName, str);
 return false;
}

//------------------------------------------------------------------------------
this.IsInputVisibleAndEditable = function(input)
{
 if (input && input.style && input.style.display && input.style.display == "none")
  return false;

 if (input && input.style && input.style.visibility && 
     (input.style.visibility == "hidden" || input.style.visibility == "collapse"))
  return false;

 if (input && (input.disabled || input.readOnly))
  return false;

 return true;
}

//------------------------------------------------------------------------------
this.ParseMenuLine = function(line)
{
 var menu_name = "";
 var menu_value = "";
 if (line.length > 0)
 {
   line = this.HideSharp(line);
   var tmp = line.split ("#");
   if (tmp.length > 1)
   {
     var arraySize = tmp.length;
     if (arraySize == 2) // no macros
     {
      menu_name = this.UnhideSharp(tmp[1]);
      menu_value = this.HideAt(this.UnhideSharp(tmp[0]));
     }
     else
     {
      menu_name = this.UnhideSharp(tmp[arraySize-1]);
      menu_value = this.Macro(tmp[arraySize-2], false);
     }
   }
   else 
   {
     menu_name = this.UnhideSharp(line);
     menu_value = this.HideAt(this.UnhideSharp(line));
   }
 }
 var result = new Array(menu_name, menu_value);
 return result;
}

//------------------------------------------------------------------------------

this.GetCurrentProfileItemsCountInFormCache = function(inputName)
{
 var itemsCount = 0;
 if(this.g_FormHistory && this.g_IsOn && this.g_ColorizeItems)
 {
  var profileId = this.GetPrefInt("InFormEnter.ProfileCurrent", 1);
  this.g_MenuSet = this.GetPrefChar("InFormEnter."+profileId+".MenuSet", "");

  var menuTextItems = unescape(this.g_MenuSet).split("\n"); 
  var lines_count = menuTextItems.length;
  for (var i=0; i<lines_count; i++)
  {
   var resultArray = this.ParseMenuLine(menuTextItems[i]);
   var menu_value = resultArray[1];
   if(this.IsStrInFormCache(inputName, menu_value))
    itemsCount++;
  }
 }
 return itemsCount;
}

//------------------------------------------------------------------------------

this.GetCurrentProfileFirstItemFromFormCache = function(inputName)
{
 if(this.g_FormHistory && this.g_IsOn && this.g_ColorizeItems)
 {
  var profileId = this.GetPrefInt("InFormEnter.ProfileCurrent", 1);
  this.g_MenuSet = this.GetPrefChar("InFormEnter."+profileId+".MenuSet", "");

  var menuTextItems = unescape(this.g_MenuSet).split("\n"); 
  var lines_count = menuTextItems.length;
  for (var i=0; i<lines_count; i++)
  {
   var resultArray = this.ParseMenuLine(menuTextItems[i]);
   var menu_value = resultArray[1];
   if(this.IsStrInFormCache(inputName, menu_value))
   {
    return menu_value;
   }
  }
 }
 return "";
}

//------------------------------------------------------------------------------
this.PopupFill = function(menuitemID, inputName, inputMaxLength)
{
 this.CheckDefaultProfile();

 // ??? ife_common.js::this.g_MenuSet != ife_options.js::this.g_MenuSet  
 var profileId = this.GetPrefInt("InFormEnter.ProfileCurrent", 1);
 this.g_MenuSet = this.GetPrefChar("InFormEnter."+profileId+".MenuSet", "");
 var toShowSize = this.GetPrefInt("InFormEnter."+profileId+".ShowSize", 0);
 this.g_MenuItemsCount = 0;
 var mi_from_form_cache_last = null;
 var mi_from_form_cache_count = 0;

 var mi_hint = document.getElementById(menuitemID);
 var mi_sep = mi_hint.nextSibling.nextSibling;

 // remove previous menu
 while (mi_sep.nextSibling != null)
  mi_sep.parentNode.removeChild (mi_sep.nextSibling);

 // template
 var mi_template = mi_hint.cloneNode(true);
 mi_template.setAttribute("disabled", false);

 // create new items
 var menuTextItems = unescape(this.g_MenuSet).split("\n"); 
 var lines_count = menuTextItems.length;
 for (var i=0; i<lines_count; i++)
 {
   var line = menuTextItems[i];
   var resultArray = this.ParseMenuLine(line);
   var menu_name = resultArray[0];
   var menu_value = resultArray[1];

   if (menu_name != "" && menu_value != "#SR#")
   {
     var mi_new = mi_template.cloneNode(true);
     mi_new.setAttribute("label", this.CheckMenuItemLength(menu_name));
     if (toShowSize)
      mi_new.setAttribute("acceltext", "["+menu_value.length+"]");
     mi_new.setAttribute("oncommand", "InFormEnter.OnMenuItemSelect(" + i + ", event);");
     if (this.IsStrInFormCache(inputName, menu_value))
     {
      mi_new.setAttribute("image", "chrome://informenter/skin/arrow_inhistory.png");
      mi_from_form_cache_last = mi_new;
      mi_from_form_cache_count++;
     }
     mi_hint.parentNode.appendChild (mi_new);
     this.g_MenuItemsCount++;
   }
   if (menu_value == "#SR#")
   {
     var mi_new_sep = mi_sep.cloneNode(true);
     mi_new_sep.setAttribute("hidden", false);
     mi_hint.parentNode.appendChild (mi_new_sep);
   }
 }

 // hint
 var hint_label; 
 if (this.g_MenuItemsCount == 0)
   hint_label = this.GetPropStr("ife.msg.setup"); 
 else
   hint_label = this.StrMaxInputLength (inputMaxLength);
 mi_hint.setAttribute("label", hint_label);

 // check form cache count
 if(mi_from_form_cache_count == 1)
  mi_from_form_cache_last.setAttribute("image", "chrome://informenter/skin/arrow_inhistory_one.png");

 // separator
 mi_sep.setAttribute("hidden", (this.g_MenuItemsCount == 0));
}

}

var InFormEnterCommon = new InFormEnterCommonType();
InFormEnterCommon.Init();
InFormEnterCommon.ReadState();



